struct tcp_connection
{
    int port;           /* port # */
    int sock;           /* the socket descripter */
    int state;          /* < 0 is not connected.  >= 0 is connected.  */
    int datalen;        /* amount of data in sock's buffer */
    int tool;           /* extra *USED* int, for misc shit */
    int open;           /* state often gets changed, this will be 1 if we
                            ever received a succesful connection */
    struct tcp_connection *next;
    struct tcp_connection *previous;
};

struct host
{
    char *host;     /* IN THE FORM TO WHICH THE VICTIM WAS  GIVIN */
    char *name;     /* THE DNS NAME */
    u_long ip;       /* THE IP ADDRESS*/
 
    time_t scan_time;   /* the time the scan began */
    
    /* OS DETECTION STUFF */
    char *os;         /* Operating System */
    char osdetect_tool;  /* Used to determine whether init_osdetect() has been called */
    char fingerprint_string[128];
    int response[5];
    int response_window[5];
    
    char *telnet_banner;
    char *imap_banner;
    char *pop3_banner;
    char *smtp_banner;
    char *http_server;
    char *ftp_banner;
    char *ftp_syst;
    char  anonymous_ftp; /* does the host support anonymous ftp logins? */
    
    char ping_reply;
     
    /* TCP CONNECTION STUFF */
    struct tcp_connection *tcp_first;
    struct tcp_connection *tcp_current;
    struct tcp_connection *tcp_previous;

    /* DNS STUFF */
    int udp_sock;
    int udp_sock_tool;
    char *bind_version;

};

struct config
{
    int port[MAX_PORT];   /* 64 ports possible */
    u_long local_ip; /* IP address of the machine you're scanning from */

    char *host_file; /* host file */
    char *single_host;
    char *device;   /* pcap device */
    
    int timeout;    /* # of seconds to wait for incoming data  */
    int fork_num;       /* whether or not prescan is to be forked, and how many times
                        it needs to be forked. */

    char debug;      /* debug level. 0 by default. */
    char stealth;   /* stealth mode (syn portscan, os detection, no ping or banner grabbing */
    char stdout_o;     /* output to stdout? */
    char savescan;    /* save the scan? */
    char stdin_i;      /* host's from stdin? */
    char got_root;   /* got r00t? */
    char r_lookup;  /* reverse lookup IP address? */
    char db_setup;
  
    /* DATABASE */
    char *db_server;
    char *db_database;
    char *db_user;
    char *db_pass;
};
    
struct pseudohdr
{
  unsigned int saddr;
	unsigned int daddr;
	unsigned char mbz;
	unsigned char protocol;
	unsigned short tcp_length;
};
    

