#include "prescan.h"

struct host *add_victim(char *);
void del_victim(struct host *);

struct host *add_victim(char *hostname)
{

  struct host *victim;

  if(!hostname) return NULL;
  
  victim = (struct host*) Malloc(sizeof(struct host));

  bzero(victim,sizeof(struct host*));


  /* DNS INFO */
  victim->name = NULL;

  /* FTP INFORMATION */
  victim->ftp_banner = NULL;
  victim->ftp_syst = NULL;

  /* MISC BANNERS/SERVERS */
  victim->telnet_banner = NULL;
  victim->imap_banner = NULL;
  victim->pop3_banner = NULL;
  victim->smtp_banner = NULL;
  victim->http_server = NULL;
  victim->bind_version = NULL;

  /* OS FINGERPRINTING */
  victim->os = NULL;

    /* TCP CONNECTION STUFF */
  victim->tcp_current = NULL;
  victim->tcp_first = NULL;
  victim->tcp_previous = NULL;

  victim->host = (char*) Malloc(strlen(hostname)+1);
  sprintf(victim->host,"%s\0",hostname);

  return victim;
}

void del_victim(struct host *victim)
{
  struct tcp_connection *tcp_tmp;
  
  Free(victim->host);
  //Free(victim->name);
  Free(victim->os);
  Free(victim->telnet_banner);
  Free(victim->imap_banner);
  Free(victim->pop3_banner);
  Free(victim->smtp_banner);
  Free(victim->http_server);
  Free(victim->ftp_banner);
  Free(victim->ftp_syst);

  for(victim->tcp_current=victim->tcp_first,tcp_tmp=victim->tcp_current;tcp_tmp;victim->tcp_current=tcp_tmp)
  {
    tcp_tmp = victim->tcp_current->next;
    Free(victim->tcp_current);
    victim->tcp_current=NULL;
  }

  Free(victim);

}
