#include "prescan.h"

void output(struct host *);

void output(struct host *victim)
{
  char *file_name;
  FILE *output_f;
  time_t timestamp;
  MYSQL_RES *res;
  MYSQL_ROW row;
  char query_string[2056];
  char chr_local_ip[30],chr_victim_ip[30];
  
  
  /* DATABASE */
  
  sprintf(chr_local_ip,"%s\0",(char*)Inet_ntoa(config.local_ip));
  sprintf(chr_victim_ip,"%s\0",(char*)Inet_ntoa(victim->ip));
  timestamp = time(NULL);
  
  db_connect();

  /* CHECK TO SEE IF ALREADY SCANNED, IF IT IS, ERASE THE DATABASE INFORMATION */  
  sprintf(query_string,"SELECT * FROM prescanic_ip WHERE source_ip = \"%s\" AND ip = \"%s\";\0",chr_local_ip,chr_victim_ip);
  send_query(query_string);
  
  res = mysql_use_result(&mysql);
  
  row = mysql_fetch_row(res);
  
  mysql_free_result(res);

  if(row != NULL)
  {


  	sprintf(query_string,"DELETE FROM prescanic_data WHERE source_ip = \"%s\" AND ip = \"%s\";\0",chr_local_ip,chr_victim_ip);
  	send_query(query_string);
  	
  	sprintf(query_string,"DELETE FROM prescanic_ip WHERE source_ip = \"%s\" AND ip = \"%s\";\0",chr_local_ip,chr_victim_ip);
  	send_query(query_string);
  	
  }
  else
  {
    /* ================== */
    /* PRESCANIC_IP TABLE */
    /* ================== */

  	bzero(query_string,sizeof(query_string));
  	sprintf(query_string,"INSERT INTO prescanic_ip (source_ip,ip,hostname,reverse_name,scan_time,ping_reply,fingerprint,os_type,ftp_syst,ftp_anonymous,prescanic_version) VALUES(\"%s\",\"%s\",\"%s\",\"%s\",FROM_UNIXTIME(%d),\"%s\",\"%s\",\"%s\",\"%s\",\"%s\",\"%s\");",chr_local_ip,chr_victim_ip,victim->host,(victim->name ? victim->name : ""),(int)timestamp,(victim->ping_reply ? "YES" : "NO"),victim->fingerprint_string,(victim->os ? victim->os : "UNKNOWN"),victim->ftp_syst,(victim->anonymous_ftp ? "YES" : "NO"),VERSION);

	
	  if(config.debug) printf("SENDING QUERY TO INSERT NEW IP IN TO TABLE.\n[%s]\n",query_string);  	

  	send_query(query_string);  	
  }
  
    /* ==================== */
    /* PRESCANIC_DATA TABLE */
    /* ==================== */
  

  /* INSERT OPEN PORTS */
  for(victim->tcp_current=victim->tcp_first; victim->tcp_current; victim->tcp_current = victim->tcp_current->next)
  {
  	if(victim->tcp_current->open)
  	{
  		sprintf(query_string,"INSERT INTO prescanic_data (source_ip,ip,port,protocol,banner) VALUES(\"%s\",\"%s\",\"%d\",\"TCP\",\"\");\0",chr_local_ip,chr_victim_ip,victim->tcp_current->port);
  		send_query(query_string);
    }
  }
  
  /* INSERT BANNERS */
  
  if(victim->pop3_banner)
  {
  	sprintf(query_string,"UPDATE prescanic_data SET banner = \"%s\" WHERE source_ip = \"%s\" and ip = \"%s\" and port = %d;\0",victim->pop3_banner,chr_local_ip,chr_victim_ip,110);
  	send_query(query_string);
  }
  
  if(victim->imap_banner)
  {
  	sprintf(query_string,"UPDATE prescanic_data SET banner = \"%s\" WHERE source_ip = \"%s\" and ip = \"%s\" and port = %d;\0",victim->imap_banner,chr_local_ip,chr_victim_ip,143);
  	send_query(query_string);
  }
  if(victim->smtp_banner)
  {
  	sprintf(query_string,"UPDATE prescanic_data SET banner = \"%s\" WHERE source_ip = \"%s\" and ip = \"%s\" and port = %d;\0",victim->smtp_banner,chr_local_ip,chr_victim_ip,25);
  	send_query(query_string);
  }
  if(victim->http_server)
  {
  	sprintf(query_string,"UPDATE prescanic_data SET banner = \"%s\" WHERE source_ip = \"%s\" and ip = \"%s\" and port = %d;\0",victim->http_server,chr_local_ip,chr_victim_ip,80);
  	send_query(query_string);
  }
  if(victim->bind_version)
  {
  	sprintf(query_string,"UPDATE prescanic_data SET banner = \"%s\" WHERE source_ip = \"%s\" and ip = \"%s\" and port = %d;\0",victim->bind_version,chr_local_ip,chr_victim_ip,53);
  	send_query(query_string);
  }
  if(victim->telnet_banner)
  {
  	sprintf(query_string,"UPDATE prescanic_data SET banner = \"%s\" WHERE source_ip = \"%s\" and ip = \"%s\" and port = %d;\0",victim->telnet_banner,chr_local_ip,chr_victim_ip,23);
  	send_query(query_string);
  }  	 
  if(victim->ftp_banner)
  {
  	sprintf(query_string,"UPDATE prescanic_data SET banner = \"%s\" WHERE source_ip = \"%s\" and ip = \"%s\" and port = %d;\0",victim->ftp_banner,chr_local_ip,chr_victim_ip,21);
  	send_query(query_string);
  }  



  /* DONE WITH DATABASE */

  db_disconnect();
  
  printf("[----> SCAN SAVED TO MYSQL DATABASE (%s)\n",config.db_database);

	/* STD OUT AND FILE SAVE */

  print_it:
  if(config.stdout_o && output_f != stdout)
    output_f = stdout;

  else if(config.savescan)
  {
    file_name = (char*) Malloc(16 + strlen(EXT));
    sprintf(file_name,EXT,chr_victim_ip);

    output_f = fopen(file_name,"a");
    if(output_f == NULL)
    {
      perror("error opening output file");
      exit(-1);
    }
  }

  timestamp = time(NULL);

  if(config.stealth)
    fprintf(output_f,"[----> STEALTH SCAN ON [%s] COMPLETED IN %d SECONDS\n",victim->host,(int)(timestamp-victim->scan_time));
  else
    fprintf(output_f,"[----> SCAN ON [%s] COMPLETED IN %d SECONDS\n",victim->host,(int)(timestamp-victim->scan_time));

  fprintf(output_f,"[> HOST:\t%s (%s)\n",Inet_ntoa(victim->ip),(victim->name ? victim->name : "DNS NAME UNKNOWN"));
  fprintf(output_f,"[> SCAN TIME:\t%s",ctime(&timestamp));
  fprintf(output_f,"[> OS TYPE:\t%s\n",(victim->os ? victim->os : "UNKNOWN"));

  if(config.stealth)
    fprintf(output_f,"[> PING REPLY:\tN/A  (STEALTH MODE)\n");
  else
    fprintf(output_f,"[> PING REPLY:\t%s\n",(victim->ping_reply ? "YES" : "NO"));

  victim->tcp_current=victim->tcp_first;

  fprintf(output_f,"[----> TCP PORTS\n");

  fprintf(output_f,"[> OPEN:\t");
  for(victim->tcp_current=victim->tcp_first; victim->tcp_current; victim->tcp_current = victim->tcp_current->next)
  {
    if(victim->tcp_current->open)
      fprintf(output_f,"[%d] ",victim->tcp_current->port);
  }
  fprintf(output_f,"\n");

  fprintf(output_f,"[> REJECTED:\t");
  for(victim->tcp_current=victim->tcp_first; victim->tcp_current; victim->tcp_current = victim->tcp_current->next)
    if(victim->tcp_current->state == REJECTED)
      fprintf(output_f,"[%d] ",victim->tcp_current->port);
  fprintf(output_f,"\n");
  fprintf(output_f,"[> NO ROUTE:\t");
  for(victim->tcp_current=victim->tcp_first; victim->tcp_current; victim->tcp_current = victim->tcp_current->next)
    if(victim->tcp_current->state == NOROUTE)
      fprintf(output_f,"[%d] ",victim->tcp_current->port);
  fprintf(output_f,"\n");

  fprintf(output_f,"[> UNREACHABLE:\t");
  for(victim->tcp_current=victim->tcp_first; victim->tcp_current; victim->tcp_current = victim->tcp_current->next)
    if(victim->tcp_current->state == N_UNREACH)
      fprintf(output_f,"[%d] ",victim->tcp_current->port);
  fprintf(output_f,"\n");

  if(config.stealth) 
    fprintf(output_f,"[----> BANNERS (N/A, STEALTH MODE)\n");
  else
    fprintf(output_f,"[----> BANNERS\n");

  if(victim->pop3_banner)
    fprintf(output_f,"[> POP3: %s\n",victim->pop3_banner);
  if(victim->imap_banner)
    fprintf(output_f,"[> IMAP: %s\n",victim->imap_banner);
  if(victim->smtp_banner)
    fprintf(output_f,"[> SMTP: %s\n",victim->smtp_banner);
  if(victim->http_server)
    fprintf(output_f,"[> HTTP: %s\n",victim->http_server);
  if(victim->bind_version)
    fprintf(output_f,"[> DNS: %s\n",victim->bind_version);
  if(victim->ftp_banner)
  {
    fprintf(output_f,"[> FTP : %s\n",victim->ftp_banner);
    if(victim->ftp_syst)
      fprintf(output_f,"[> FTP SYST: %s\n",victim->ftp_syst);
    if(victim->anonymous_ftp)
      fprintf(output_f,"[> FTP supports anonymous logins.\n");
    else
      fprintf(output_f,"[> FTP does NOT support anonymous logins.\n");
  }
  if(victim->telnet_banner)
    fprintf(output_f,"[> TELNET: %s\n",victim->telnet_banner);
  if(config.savescan && output_f == stdout) goto print_it; 
  
  if(config.savescan)
  {
    fclose(output_f);
    printf("[----> SCAN SAVED: %s\n\n",file_name);
  }
  free(file_name); 
}
