#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <pcap.h>       /* packet capture lib */
#include <unistd.h>
#include <sys/time.h>
#include <netdb.h>		/* gethostbyaddr,gethostbyname */
#include <sys/socket.h>		/* socket,connect */
#include <sys/types.h>
#include <errno.h>              /* errno stuff */
#include <fcntl.h>		/* flag control,non blocking sockets */
#include <sys/ioctl.h>
#include <arpa/inet.h>
#include <net/if.h>     /* ioctl, ifconf shit */
#include <netinet/in.h>		/* struct hostent */
#include <netinet/ip.h>
#include <netinet/ip_icmp.h>
#include <netinet/in_systm.h>
#include <netinet/tcp.h>
#include <netinet/udp.h>
#include <time.h>
#include <arpa/nameser.h>
#include <ctype.h>
#include "/usr/include/mysql/mysql.h"

#define VERSION "0.8"

#define EXT "scans/prescan.%s\0"
#define FINGERPRINTS_FILE   "prescan.fingerprints"
#define HTTPDIR_FILE       "prescan.http.dir"
#define HTTPVULN_FILE      "prescan.http.vuln"
#define MYSQLCONFIG_FILE    "prescan.dbconfig"
#define SNAPLEN 100  /* 60 is the maximum tcp header, + 20 for the ip header, + 14 (possible ethernet header) + 6, just incase*/
#define CMD "tcp or icmp or udp"
#define SEPERATOR "[8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*]\n"
#define PING_SIZE   8 /* length of data appended to ICMP_ECHO packets. */
#define SYN_SOURCE 6000 /* starting source port for syn scan */
#define MAX_PORT  64    /* maximum # of ports to scan */

#include "struct.h"

/* GLOBAL VARIABLES */
extern struct config config;
extern int datalink;		/* pcap */
extern pcap_t *pd;		/* pcap */
extern MYSQL mysql;   


/* TCP PORT STATUS DEFINES */
#define CONNECTED   0   /* currently connected, anything > 0 is the amount of data */
#define LOCAL_RESET -1  /* reset by us, in purpose */
#define PEER_RESET  -2  /* reset by peer, possibly tcp wrappers */
#define PROGRESS    -3  /* no response, or in progress */
#define REJECTED    -4  /* connection rejected */
#define NOROUTE     -5  /* no route to host */
#define N_UNREACH   -6  /* network unreachable */
#define UNKNOWN     -7  /* unknown */

/* SOURCE PORT #'S FOR OS DETECTION. */
#define PORT_1  31337
#define PORT_2  43770
#define PORT_3  55555
#define PORT_4  12345
#define PORT_5  26000

/* MORE OS DETECTION #DEFINE'S */
#define SYN         2
#define ACK         4
#define FIN         8
#define PSH         16
#define URG         32
#define RST         64
#define WINDOW      128
#define ACKNUM      256
#define SEQNUM      512

/* PROTOCOL COMMUNICATION */
#define HTTP_REQUEST    "GET / HTTP/1.0\r\n\r\n"
#define HTTPSCAN_REQUEST "GET %s HTTP/1.0\r\n"    /* len: 15 */
#define HTTPSCAN_HREQUEST "Host: %s\r\n\r\n"            /* len: 7 */
#define FTP_SYST        "SYST\r\n"
#define FTP_USER        "USER anonymous\r\n"
#define FTP_PASS        "PASS silitek@phrack.com\r\n"


