#include "prescan.h"

void *Malloc(size_t);
void Free(void *);
void strip_line_feed(char *);


void *Malloc(size_t size)
{
  char *ptr=NULL;
  ptr = malloc(size);

  if(!ptr)
  {
    perror("malloc() failed");
    exit(-1);
  }

  return ptr;
}

void Free(void *ptr)
{

  if(ptr != NULL)
  {
    free(ptr);
    ptr = NULL;
  }
}

void strip_line_feed(char *string)
{
  
  string[strlen(string) - 1] = 0;

}
